﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Public ivBackground As B4XView
	Public lblStats As B4XView
	Private Ground As X2BodyWrapper

	Public GroundLevel As Float
	
	Public mBall As Ball

	Public lblScore As B4XView

	Private PanelForTouch As B4XView 'ignore
	Public  Jump, Up, LeftDown, RightDown As Boolean

	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
'	Private Pendulum, PendulumPivot As X2BodyWrapper
End Sub


Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("GameLayout")
	world.Initialize("world", world.CreateVec2(0, -20))
	X2.Initialize(Me, ivForeground, world)
	X2.GraphicCache.MAX_SIZE_FOR_ANTIALIAS = 300
'	'Configure the dimensions. Center point is (0, 3) and the visible width is 6 meters.
'	X2.ConfigureDimensions(world.CreateVec2(0, 3), 9)
	Dim WorldWidth As Float = 9 'meters
	Dim WorldHeight As Float = WorldWidth / 1.777'1.333 'same ratio as in the designer script
	X2.ConfigureDimensions(world.CreateVec2(WorldWidth / 2, WorldHeight / 2), WorldWidth)
	
	'Load the graphics and add them to the cache.
	CreateStaticBackground
	'comment to disable debug drawing
'	X2.EnableDebugDraw
	'
	LoadBallGraphics
	LoadChainGraphics
	
	X2.SoundPool.AddSound("wing", File.DirAssets, "wing.mp3")
	
	TileMap.Initialize(X2, File.DirAssets, "world.json", Null)
	TileMap.SetSingleTileDimensionsInMeters(WorldWidth / TileMap.TilesPerRow, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef(ObjectLayer)
	
'	X2.SlowDownPhysicsScale = 5
'	X2.UpdateTimeParameters
End Sub

Private Sub LoadBallGraphics
	'Load the ball graphics and add them to the cache.

	Dim sb As X2ScaledBitmap = X2.LoadBmp(File.DirAssets, "ball-1.png", 1, 1 , True)
	X2.GraphicCache.PutGraphic2("ball", Array(sb), True, 3)
	'The ball can rotate fast so it is better to build the cache before we start.
	X2.GraphicCache.WarmGraphic("ball")
	
End Sub

Private Sub LoadChainGraphics
	' Kette	
	Dim all As List = X2.ReadSprites(xui.LoadBitmap(File.DirAssets, "chain.png"), 1, 2, .5, .5)
	X2.GraphicCache.PutGraphic2("chain", Array(all.Get(0), all.Get(1)),True,1)
	X2.GraphicCache.WarmGraphic("chain")
	
End Sub

Public Sub StartGame
	If X2.IsRunning Then Return

	Jump = False
	
	X2.Reset
	X2.UpdateWorldCenter(X2.CreateVec2(0, 3))

	CreateChain(25, 1, 1.)

	CreateGround
	
	X2.Start
'	X2.AddFutureTask(Me, "Create_Ball", 500, Null)

End Sub

Public Sub Stop
	X2.Stop
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	
End Sub

Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub

Public Sub Tick (GS As X2GameStep)
	Dim aVec As Int = 0
	If LeftDown Then aVec = -1
	If RightDown Then aVec = 1
	For Each bd As B2Body In world.AllBodies

		Dim bw As X2BodyWrapper = bd.Tag
		If bw.Name = "ball" Then _
			bd.ApplyForce( X2.CreateVec2(aVec * 5, 0),bd.WorldCenter)
		
	Next
End Sub

Private Sub CreateStaticBackground
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale / 2, ivBackground.Height / xui.Scale / 2)
	bc.FillGradient(Array As Int(0xFF006EFF, 0xFF00DAAD), bc.TargetRect, "TOP_BOTTOM")
	X2.SetBitmapWithFitOrFill(ivBackground, bc.Bitmap)
End Sub

Private Sub Create_Ball(ft As X2FutureTask)
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_DYNAMIC
	bd.Position = X2.CreateVec2(X2.ShapeAABB.Width /2 , 4)
	bd.LinearVelocity = X2.CreateVec2(5, -1)
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, mBall, "ball")
	wrapper.GraphicName = "ball"
	mBall.Initialize(wrapper)
	Dim Fix As B2FixtureDef
	Dim size As B2Vec2 = X2.GraphicCache.GetGraphicSizeMeters(wrapper.GraphicName, 0)
	Dim circle As B2CircleShape
	circle.Initialize(size.Y / 2.1)
	Fix.Shape = circle
	Fix.Restitution=0.6
	Fix.Friction = 1
	Fix.Density = 0.2
'	wrapper.Body.CreateFixture2(circle, 0.2)
	wrapper.Body.CreateFixture(Fix)
End Sub


Private Sub CreateGround
	Dim GroundBox As B2Vec2 = X2.CreateVec2(9.6, 0.96)
	Dim sb As X2ScaledBitmap = X2.LoadBmp(File.DirAssets, "ground.png", GroundBox.X, GroundBox.Y, False)
	X2.GraphicCache.PutGraphic("Ground", Array(sb))
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_STATIC 'the engine should not move it
	bd.Position = X2.CreateVec2(X2.ScreenAABB.Center.X, X2.ScreenAABB.BottomLeft.Y + GroundBox.Y / 2)
	Ground = X2.CreateBodyAndWrapper(bd, Null, "Ground")
	Ground.GraphicName = "ground"
	Dim rect As B2PolygonShape
	rect.Initialize
	rect.SetAsBox(GroundBox.X / 2, GroundBox.Y / 2)
	Ground.Body.CreateFixture2(rect, 1)
	GroundLevel = X2.ScreenAABB.BottomLeft.Y + GroundBox.Y+1
	Dim edge As B2EdgeShape
	edge.Initialize( X2.CreateVec2(-20, X2.ScreenAABB.TopRight.Y - bd.Position.Y - 0.01), _
		X2.CreateVec2(20, X2.ScreenAABB.TopRight.Y - bd.Position.Y - 0.01))
	Ground.Body.CreateFixture2(edge, 0)
	
	Dim Fix As B2FixtureDef
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_STATIC 'the engine should not move it
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "Right")
	Dim edge As B2EdgeShape
	edge.Initialize(X2.CreateVec2(X2.ScreenAABB.TopRight.X, -10), X2.CreateVec2(X2.ScreenAABB.TopRight.X, 10))	
	Fix.Shape = edge
	Fix.Restitution=0.5
	Fix.Friction = 0.0
	Fix.Density = 1
	wrapper.Body.CreateFixture(Fix)
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "Left")
	Dim edge As B2EdgeShape
	edge.Initialize(X2.CreateVec2(X2.ScreenAABB.BottomLeft.X, -10), X2.CreateVec2(X2.ScreenAABB.BottomLeft.X, 10))
	Fix.Shape = edge
	Fix.Restitution=0.5
	Fix.Friction = 0.0
	Fix.Density = 1
	wrapper.Body.CreateFixture(Fix)
End Sub

Private Sub CreateChain(intChainParts As Int, xAnchor As Float, yAnchor As Float)
	
	Dim BodyA, BodyB As X2BodyWrapper
	
	Dim x,y As Float
	
	Dim template As X2TileObjectTemplate = TileMap.GetObjectTemplateByName(ObjectLayer,"pendulum pivot")
	template.BodyDef.Position = X2.CreateVec2(0 , X2.ScreenAABB.TopRight.Y)
	TileMap.CreateObject(template)
	
	Dim PendulumPivot As X2BodyWrapper = X2.GetBodyWrapperByName("pendulum pivot")
	
	x = PendulumPivot.Body.WorldCenter.X  ' all ChainParts on the same x-coordinate
	yAnchor = PendulumPivot.Body.WorldCenter.Y - PendulumPivot.X2.ShapeAABB.Height/2
	
	Dim template As X2TileObjectTemplate = TileMap.GetObjectTemplateByName(ObjectLayer, "chain")
	template.BodyDef.Position = X2.CreateVec2(x, yAnchor)
	Dim BodyA As X2BodyWrapper = TileMap.CreateObject(template)
	
	
	Dim PartHeight As Float = BodyA.X2.ShapeAABB.Height
	
	Dim revdef1 As B2WeldJointDef
	revdef1.Initialize(PendulumPivot.Body, BodyA.Body, X2.CreateVec2(x, yAnchor))
	world.CreateJoint(revdef1)
	'
	Dim template As X2TileObjectTemplate = TileMap.GetObjectTemplateByName(ObjectLayer, "chain")
'	Dim revdef As B2DistanceJointDef 
'	Dim revdef As B2WheelJointDef
	Dim revdef As B2RevoluteJointDef
	
	For i = 0 To intChainParts
		'
		y = yAnchor - (i * PartHeight) * 0.7
		'
		template.BodyDef.Position = X2.CreateVec2(x, y)
		Dim BodyB As X2BodyWrapper = TileMap.CreateObject(template)
			
		If (i Mod 2 = 0) Then
			BodyB.CurrentFrame = 0
		Else
			BodyB.CurrentFrame = 1
		End If
		'
'		If i=0 Then
''			revdef.Initialize(PendulumPivot.Body, BodyB.Body, X2.CreateVec2(x, y))
'			revdef.Initialize(PendulumPivot.Body, BodyB.Body, X2.CreateVec2(0, PartHeight*0.9),  X2.CreateVec2(0,0))
'		Else
		revdef.Initialize(BodyA.Body, BodyB.Body, X2.CreateVec2(0, y))

'		revdef.Initialize(BodyA.Body, BodyB.Body,  BodyA.Body.Position, BodyB.Body.Position)
'		End If
		'
'		revdef.MaxMotorTorque = 0.
'		revdef.MotorSpeed = 0.0
'		revdef.MotorEnabled = True
'		revdef.SetLimits(-cPI,cPI)
'		revdef.LimitEnabled = True
		
'		revdef.DampingRatio = 1
'		revdef.FrequencyHz = 30
		'
		world.CreateJoint(revdef)
		'
		BodyA.Body = BodyB.Body
	Next
End Sub


Private Sub World_BeginContact (Contact As B2Contact)

End Sub



'#if B4A or B4i
Sub PanelForTouch_Touch (Action As Int, X As Float, Y As Float)
	If Action = PanelForTouch.TOUCH_ACTION_DOWN Then
		Jump = True
		Up = False
	else If Action = PanelForTouch.TOUCH_ACTION_UP Then
		Up = True
'	Else If Action = Panel1.TOUCH_ACTION_MOVE_NOTOUCH Then
'		Up = True
	End If
End Sub
'#end if